package appointment.backing;

import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.faces.context.FacesContext;
import javax.faces.model.SelectItem;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
	
public class AppointmentFacesManager1 {
		
		Log log = LogFactory.getFactory().getInstance(getClass());
	
		
		private AppointmentBook book = new AppointmentBook();
		private String[] selectItemProviders = new String[0];
		
		public AppointmentBook getBook() {
			return book;
		}
	
		public String addProvider() {
			
			FacesContext ctx =FacesContext.getCurrentInstance();
			
			Map map =ctx.getExternalContext().getRequestMap();
			
			Provider provider = (Provider) map.get("provider");
			Set keys = ctx.getExternalContext()
			.getSessionMap().keySet();
			Iterator i = keys.iterator();
			while (i.hasNext()) {
				log.info("Application key = " + i.next());
			} 
			
			try {
				Provider copy = (Provider)BeanUtils.cloneBean(provider);
				book.addProvider(copy);
			} catch (IllegalAccessException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InstantiationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (InvocationTargetException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (NoSuchMethodException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			 
			provider.clear();
			/*
				map.put("provider", new Provider());
				this doesn't work, as the form keeps hold
				of the original reference ?
				
			*/
			
			
			LogFactory.getFactory().getInstance(getClass()).info("added provider to " + book.toString());
			
			return "success"; 
			
		}
	
		public void rollDayForward() {
			getBook().rollDay(true);
		}
		
		public void rollDayBackward() {
			getBook().rollDay(false);
		}
		
		public void rollWeekForward() {
			getBook().rollWeek(true);
		}
		

		public void rollWeekBackward() {
			getBook().rollWeek(false);
		}
		
		public void rollMonthForward() {
			getBook().rollMonth(true);
		}
		

		public void rollMonthBackward() {
			getBook().rollMonth(false);
		}
		
		public void setToday() {
			getBook().setCurrentDate(new Date());
		}
		
		public SelectItem[] getSelectProviders() {
			Iterator i = getBook().getProviders().iterator();
			List l = new ArrayList();
			while (i.hasNext()) {
				Provider p = (Provider)i.next();
				l.add( new SelectItem(Long.toString(p.getId()), p.getName() ));
			}
			return (SelectItem[]) l.toArray(new SelectItem[0]);
		}
		 
		public void setChosenProviders(String[] items) {
			selectItemProviders = items;
		}
		
		public String[] getChosenProviders() {
			return selectItemProviders;
		}
		
		public List getSelectedProviders() {
			
			HashSet set = new HashSet();
			for (int j = 0; j < selectItemProviders.length;++j) {
				set.add( selectItemProviders[j]);
				log.debug("select set has " +selectItemProviders[j] );
			}
			
			List l = new ArrayList();
			Iterator i = getBook().getProviders().iterator();
			while (i.hasNext()) {
				Provider p = (Provider)i.next();
				
				if (set.contains( Long.toString(p.getId())) ) {
					l.add(p);
					log.debug("added "+p.getName());
				} else {
					log.debug(p.getName()+" "+p.getId() + "not in set");
				}
			}
			book.setSelectedProviders(l);
			return l;
		}
}
