package appointment.backing;

import java.io.Serializable;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class AppointmentSlot implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 7237251430587664568L;
	private static Log log ;
	static {
		log = LogFactory.getLog(AppointmentSlot.class);
	}
	private Time start = new Time();
	private Time end = new Time();
	
	private Appointment appointment = new Appointment();
	
	public boolean isEmpty() {
		return appointment == null 
		|| appointment.getName() == null
		|| appointment.getName().trim().length() == 0;
	}
	
	public String getViewClass() {
		return isEmpty() ? "empty": 
			"filled";
	}
	
	public AppointmentSlot() {}
	public AppointmentSlot(Appointment appt, final Time current, final Time next) {
		// TODO Auto-generated constructor stub
		this.start = new Time(current);
		this.end = new Time( next) ;
		this.appointment = appt;
		log.info("created new slot appointment start=" + this.start + " end =" + this.end);
	}
	
	

	public Appointment getAppointment() {
		return appointment;
	}

	public void setAppointment(Appointment appointment) {
		this.appointment = appointment;
	}

	public Time getStart() {
		return start;
	}

	public void setStart(Time start) {
		this.start = start;
	}
	
	public Time getEnd() {
		return this.end;
	}
	public void setEnd(final Time end) {
		this.end = end;
	}
}
