package appointment.backing;

import java.io.Serializable;

public class Period implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = -5854416421852934676L;

	Time start, end;
	
	public Period() {}
	
	public Period(Time curr, Time currEnd) {
		// TODO Auto-generated constructor stub
		this();
		setStart(curr);
		setEnd(currEnd);
	}


	public Time getEnd() {
		return end;
	}
	public void setEnd(Time end) {
		if (!isStartBeforeEnd(this.start, end))
			return;
		this.end = end;
	}
	public Time getStart() {
		return start;
	}
	public void setStart(Time start) {
		if (this.end != null && !isStartBeforeEnd(start, this.end))
			return;
		this.start = start;
	}
	
	boolean isStartBeforeEnd(Time start2, Time end2) {
		if (start2 == null )
			return true;
		
		return start2.before(end2);
	}
	public boolean before(Object period) {
		// TODO Auto-generated method stub
		if (period instanceof Period) {
			Period period2 = (Period) period;
			return getStart().before(period2.getStart())  
			;
		}
		return true;
	}
	
	public boolean overlaps( Time start, Time end) {
		return getStart().within(start, end) || 
		 getEnd().within(start, end);
		 
	}
	 
	 
	 
	
}
