package appointment.backing;

import java.io.Serializable;
import java.text.MessageFormat;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class Time implements Serializable  {
	/**
	 * 
	 */
	private static final long serialVersionUID = 5264479996770633203L;
	private Minute minute;
	private Hour	hour;
	private static  Log log = LogFactory.getLog(Time.class);
	
	public Time() {
		minute = new Minute();
		hour = new Hour();
	}
	
	
	
	public Time(Hour hour2, Minute minute2) {
		// TODO Auto-generated constructor stub
		if ( minute2 != null )
			this.minute = new Minute(minute2);
		else
			minute = new Minute();
		
		if 	( hour2 != null)
			this.hour = new Hour(hour2);
		else
			hour = new Hour();
	}

	public Time(final Time t) {
		// TODO Auto-generated constructor stub
		this ( t.getHour(), t.getMinute());
	}



	public Time(int i, int j) {
		// TODO Auto-generated constructor stub
		this( new Hour(i), new Minute(j));
	}



	public String toString() {
		return MessageFormat.format(
					"{0,number,00}:{1,number,00}", 
					new Object[] { 
							new Integer(hour.getValue()), 
							new Integer(minute.getValue()) 
							} 
					);
	}
	
	public Time getNextTime(Minute minute) {
		
		int minuteValue = minute.getValue();		
		return getNextTime(minuteValue);
	}



	/**
	 * @param minuteValue
	 * @return
	 */
	public Time getNextTime(int minuteValue) {
		Time t = new Time();
		int tot = minuteValue + getMinuteValue();
		log.info("tot is " + tot + ", inteval is = "+minuteValue +" last minute is" + getMinuteValue());
		t.setMinuteValue(tot);
		int extraHour = getHourValue() + tot / 60;
		t.setHourValue(extraHour);
		return t;
	}
	
	public Hour getHour() {
		return hour;
	}
	public void setHour(Hour hour) {
		this.hour = hour;
	}
	public Minute getMinute() {
		
		return minute;
	}
	public void setMinute(Minute minute) {
		this.minute = minute;
	}



	public boolean moreThan(Time end) {
		// TODO Auto-generated method stub
		boolean ret = false;
		
		if (end == null) {
			ret = true;
		}  
		else if ( getHourValue() > end.getHourValue()) {
					ret=true;
		}
		else if ( getHourValue() == end.getHourValue() 
				&& getMinuteValue() > end.getMinuteValue()) {
					ret= true;
		}
		
		return ret;
	}



	public int getHourValue() {
		return hour.getValue();
	}



	public void setHourValue(int hour) {
		this.hour.setValue(hour);
	}



	public int getMinuteValue() {
		return minute.getValue();
	}



	public void setMinuteValue(int value) {
		minute.setValue(value);
	}



	public boolean before(Time end2) {
		// TODO Auto-generated method stub
		
		return !moreThan(end2);
	}

	public boolean equals( Time t) {
		if ( t == null || t.getHour() == null || t.getMinute() == null )
			return false;
		if (t.getHourValue() == (getHourValue()) && t.getMinuteValue() == getMinuteValue())
			return true;
		return false;
	}


	public boolean isEqualToOrMoreThan(Time other) {
		// TODO Auto-generated method stub
		
		return moreThan(other) || equals(other);
	}


	public boolean within(Time start, Time end) {
		return isEqualToOrMoreThan(start)
		&& before(end);
	}
 
	 
}
